/*
 * Copyright (C) 2017 Laboratoire ThéMA - UMR 6049 - CNRS / Université de Franche-Comté
 * http://thema.univ-fcomte.fr
 *
 * This program is free software: you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program.  If not, see <http://www.gnu.org/licenses/>.
 */


package org.thema.modaccess;

import org.locationtech.jts.geom.Coordinate;
import org.locationtech.jts.geom.GeometryFactory;
import org.locationtech.jts.geom.Point;
import java.awt.event.MouseEvent;
import java.awt.geom.Point2D;
import java.util.List;
import org.thema.drawshape.PanelMap.ShapeMouseListener;
import org.thema.drawshape.SelectableShape;
import org.thema.data.feature.DefaultFeature;
import org.thema.drawshape.layer.DefaultGroupLayer;
import org.thema.network.NetworkLocation;
import org.thema.common.DayTime;
import org.thema.drawshape.layer.Layer;
import org.thema.network.dijkstra.DefaultWeighter;
import org.thema.network.dijkstra.DijkstraNetworkPathFinder;
import org.thema.network.shape.NetworkPathLayer;
import org.thema.network.shape.SourceGraphLayer;


/**
 *
 * @author gvuidel
 */
public class PathDialog extends javax.swing.JDialog {

    private MainFrame mainFrm;

    /** Creates new form PathDialog */
    public PathDialog(MainFrame mainFrm) {
        super(mainFrm, false);
        this.mainFrm = mainFrm;
        initComponents();
        setLocationRelativeTo(mainFrm);
        getRootPane().setDefaultButton(okButton);

        mainFrm.getMapViewer().addMouseListener(new ShapeMouseListener() {
            boolean swap = true;
            @Override
            public void mouseClicked(Point2D p, List<SelectableShape> shapes, MouseEvent sourceEvent, int cursorMode) {
                if(swap) {
                    originTextField.setText(p.getX() + ", " + p.getY());
                } else {
                    destTextField.setText(p.getX() + ", " + p.getY());
                }
                swap = !swap;
            }
        });
    }


    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        okButton = new javax.swing.JButton();
        cancelButton = new javax.swing.JButton();
        jLabel1 = new javax.swing.JLabel();
        jLabel2 = new javax.swing.JLabel();
        originTextField = new javax.swing.JTextField();
        destTextField = new javax.swing.JTextField();
        jLabel3 = new javax.swing.JLabel();
        startTextField = new javax.swing.JTextField();
        jLabel4 = new javax.swing.JLabel();
        dayComboBox = new javax.swing.JComboBox();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        java.util.ResourceBundle bundle = java.util.ResourceBundle.getBundle("org/thema/modaccess/Bundle"); // NOI18N
        setTitle(bundle.getString("PathDialog.title")); // NOI18N
        setAlwaysOnTop(true);

        okButton.setText(bundle.getString("PathDialog.okButton.text")); // NOI18N
        okButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                okButtonActionPerformed(evt);
            }
        });

        cancelButton.setText(bundle.getString("PathDialog.cancelButton.text")); // NOI18N
        cancelButton.addActionListener(new java.awt.event.ActionListener() {
            public void actionPerformed(java.awt.event.ActionEvent evt) {
                cancelButtonActionPerformed(evt);
            }
        });

        jLabel1.setText(bundle.getString("PathDialog.jLabel1.text")); // NOI18N

        jLabel2.setText(bundle.getString("PathDialog.jLabel2.text")); // NOI18N

        originTextField.setText(bundle.getString("PathDialog.originTextField.text")); // NOI18N

        destTextField.setText(bundle.getString("PathDialog.destTextField.text")); // NOI18N

        jLabel3.setText(bundle.getString("PathDialog.jLabel3.text")); // NOI18N

        startTextField.setText(bundle.getString("PathDialog.startTextField.text")); // NOI18N

        jLabel4.setText(bundle.getString("PathDialog.jLabel4.text")); // NOI18N

        dayComboBox.setModel(new javax.swing.DefaultComboBoxModel(new String[] { "Monday", "Tuesday", "Wednesday", "Thursday", "Friday", "Saturday", "Sunday" }));

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .addContainerGap()
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
                    .add(layout.createSequentialGroup()
                        .add(jLabel1)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(originTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 368, Short.MAX_VALUE))
                    .add(layout.createSequentialGroup()
                        .add(jLabel2)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(destTextField, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, 330, Short.MAX_VALUE))
                    .add(org.jdesktop.layout.GroupLayout.TRAILING, layout.createSequentialGroup()
                        .add(okButton, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 67, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(cancelButton))
                    .add(layout.createSequentialGroup()
                        .add(jLabel3)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(startTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, 66, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(jLabel4)
                        .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED)
                        .add(dayComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)))
                .addContainerGap())
        );

        layout.linkSize(new java.awt.Component[] {cancelButton, okButton}, org.jdesktop.layout.GroupLayout.HORIZONTAL);

        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(layout.createSequentialGroup()
                .add(24, 24, 24)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel1)
                    .add(originTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(18, 18, 18)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel2)
                    .add(destTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .addPreferredGap(org.jdesktop.layout.LayoutStyle.RELATED, 34, Short.MAX_VALUE)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(jLabel3)
                    .add(startTextField, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
                    .add(jLabel4)
                    .add(dayComboBox, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE))
                .add(37, 37, 37)
                .add(layout.createParallelGroup(org.jdesktop.layout.GroupLayout.BASELINE)
                    .add(cancelButton)
                    .add(okButton))
                .addContainerGap())
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    private void okButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_okButtonActionPerformed
        String [] tok = originTextField.getText().split(",");
        Point origPoint = new GeometryFactory().createPoint(new Coordinate(Double.parseDouble(tok[0].trim()), Double.parseDouble(tok[1].trim())));
        tok = destTextField.getText().split(",");
        Point destPoint = new GeometryFactory().createPoint(new Coordinate(Double.parseDouble(tok[0].trim()), Double.parseDouble(tok[1].trim())));

        byte day = (byte) (1 << dayComboBox.getSelectedIndex());
        final long start = DayTime.string2Long(startTextField.getText());

        setVisible(false);
        dispose();

        List<NetworkLocation> srcLocs = mainFrm.getProject().getTotalNetwork().getLocations(new DefaultFeature("O", origPoint, null, null));
        List<NetworkLocation> destLocs = mainFrm.getProject().getTotalNetwork().getLocations(new DefaultFeature("D", destPoint, null, null));
        DijkstraNetworkPathFinder pathfinder = new DijkstraNetworkPathFinder(srcLocs, destLocs,
                    new DefaultWeighter(), DayTime.getTotalTime(start, day));

        pathfinder.calculate();
        DijkstraNetworkPathFinder.NetworkPath path = pathfinder.getNetworkPath(pathfinder.getBestDestLoc(destLocs));

        Layer l = new NetworkPathLayer("Path", path,
                    new SourceGraphLayer.CostFormater() {
                        @Override
                        public String format(Double cost) {
                            if(Double.isNaN(cost)) {
                                return "N";
                            } else {
                                return String.format("%02d:%02d", (int)(DayTime.getTimeOfDay(cost.longValue()+ start) / 3600000),
                                        (int)((DayTime.getTimeOfDay(cost.longValue()+ start) % 3600000) / 60000));
                            }
                        }
                    });
        l.setRemovable(true);
        ((DefaultGroupLayer)mainFrm.getMapViewer().getLayers()).addLayerFirst(l);

    }//GEN-LAST:event_okButtonActionPerformed

    private void cancelButtonActionPerformed(java.awt.event.ActionEvent evt) {//GEN-FIRST:event_cancelButtonActionPerformed
        setVisible(false);
        dispose();
    }//GEN-LAST:event_cancelButtonActionPerformed



    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JButton cancelButton;
    private javax.swing.JComboBox dayComboBox;
    private javax.swing.JTextField destTextField;
    private javax.swing.JLabel jLabel1;
    private javax.swing.JLabel jLabel2;
    private javax.swing.JLabel jLabel3;
    private javax.swing.JLabel jLabel4;
    private javax.swing.JButton okButton;
    private javax.swing.JTextField originTextField;
    private javax.swing.JTextField startTextField;
    // End of variables declaration//GEN-END:variables

}
